﻿
{
	var t1 = new Task<int>(() => {
		Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in task 1 ...");
		return 10;
	});
	t1.Start();
	
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: t1.Status == {t1.Status} ...");
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: calling Thread.Sleep(1000) ...");
	Thread.Sleep(1000);
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: t1.Status == {t1.Status} ...");
}
Console.WriteLine();
Console.WriteLine("Press ENTER to start example 2 ...");
Console.ReadLine(); 
{
	var t2 = new Task<int>(() => {
		Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in task 2 ...");
		throw new InvalidOperationException();
	});
	t2.Start();
	
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: t2.Status == {t2.Status}\n\tt2.Exception == {t2.Exception?.GetType()} with .InnerException == {t2.Exception?.InnerException?.GetType()} ...");
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: calling Thread.Sleep(1000) ...");
	Thread.Sleep(1000);
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: t2.Status == {t2.Status}\n\tt2.Exception == {t2.Exception?.GetType()} with .InnerException == {t2.Exception?.InnerException?.GetType()} ...");
}
Console.WriteLine();
Console.WriteLine("Press ENTER to start example 3 ...");
Console.ReadLine(); 
{
	var t3 = new Task<int>(() => {
		Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in task 3 ...");
		var cts = new CancellationTokenSource();
		cts.Cancel();
		throw new OperationCanceledException(cts.Token);
	});
	t3.Start();
	
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: t3.Status == {t3.Status}\n\tt3.Exception == {t3.Exception?.GetType()} with .InnerException == {t3.Exception?.InnerException?.GetType()} ...");
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: calling Thread.Sleep(1000) ...");
	Thread.Sleep(1000);
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: t3.Status == {t3.Status}\n\tt3.Exception == {t3.Exception?.GetType()} with .InnerException == {t3.Exception?.InnerException?.GetType()} ...");
}
Console.WriteLine();
Console.WriteLine("Press ENTER to start example 4 ...");
Console.ReadLine(); 
{
	var cts = new CancellationTokenSource();
	var t4 = new Task<int>(() => {
		Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in task 4 ...");
		Thread.Sleep(500);
		throw new OperationCanceledException(cts.Token);
	}, cts.Token);	// CT token passed to Task ctor
	t4.Start();
	
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: t4.Status == {t4.Status}\n\tt4.Exception == {t4.Exception?.GetType()} with .InnerException == {t4.Exception?.InnerException?.GetType()} ...");
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: calling Thread.Sleep(100) ...");
	Thread.Sleep(100);

	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: calling cts.Cancel() ...");	
	cts.Cancel();

	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: t4.Status == {t4.Status}\n\tt4.Exception == {t4.Exception?.GetType()} with .InnerException == {t4.Exception?.InnerException?.GetType()} ...");
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: calling Thread.Sleep(1000) ...");
	Thread.Sleep(1000);
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: t4.Status == {t4.Status}\n\tt4.Exception == {t4.Exception?.GetType()} with .InnerException == {t4.Exception?.InnerException?.GetType()} ...");
}
Console.WriteLine();
Console.WriteLine("Press ENTER to start example 5 ...");
Console.ReadLine(); {
	var cts = new CancellationTokenSource();
	var t5 = new Task<int>(() => {
		Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in task 5 ...");
		Thread.Sleep(500);
		cts.Token.ThrowIfCancellationRequested();
		return 200;	// Should never get here !!!
	}, cts.Token);  // CT token passed to Task ctor
	t5.Start();

	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: t5.Status == {t5.Status}\n\tt5.Exception == {t5.Exception?.GetType()} with .InnerException == {t5.Exception?.InnerException?.GetType()} ...");
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: calling Thread.Sleep(100) ...");
	Thread.Sleep(100);

	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: calling cts.Cancel() ...");
	cts.Cancel();

	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: t5.Status == {t5.Status}\n\tt5.Exception == {t5.Exception?.GetType()} with .InnerException == {t5.Exception?.InnerException?.GetType()} ...");
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: calling Thread.Sleep(1000) ...");
	Thread.Sleep(1000);
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: t5.Status == {t5.Status}\n\tt5.Exception == {t5.Exception?.GetType()} with .InnerException == {t5.Exception?.InnerException?.GetType()} ...");
}
Console.WriteLine();


