﻿namespace TaskCtorThenStart {
	public class Program {
		public static void Main(string[] args) {
			{
				Task? t = null;
				t = Task.Factory.StartNew(() => {
					Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in task: t == {t}");
					// Call t!.IsCompleted getter here ...
					// RACE CONDITION !!! As assignment to "t" is not atomic = READ -> WRITE, the t!.IsCompleted might result in NullReferenceException.
				});

				Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in Main: t == {t}");
				t.Wait();
			}
            
			Console.WriteLine();
            
			{
				Task? t = null;
				t = new Task(() => {
					Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in task: t == {t}");
					// Call t!.IsCompleted getter here ...
					// CORRECT !!!
				});
				
				t.Start(); // We call .Start() only after "t" was definetely assigned (WRITE to "t").
				
				Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in Main: t == {t}");
				t.Wait();
			}
		}
	}
}