﻿
{
	Task<int> t1 = Task.FromResult(22);
	Task<string> t2 = t1.ContinueWith(prevTask => {
		Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in continuation task 2 ...");
		return $"Result was {prevTask.Result} :)";
	});

	// Thread.Sleep(10);
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in Main: calling t2.Result ...");
	string result = t2.Result;
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in Main: t2.Result was \"{result}\"...");
}
Console.WriteLine();
Console.WriteLine("Press ENTER to start example 2 ...");
Console.ReadLine();
{
	var tcs1 = new TaskCompletionSource<int>();
	Task<int> t1 = tcs1.Task;
	Task<string> t2 = t1.ContinueWith(prevTask => {
		Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in continuation task 2 ...");
		return $"Result was {prevTask.Result} :)";
	});

	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in Main: getting to Sleep(1000) ...");
	Thread.Sleep(1000);
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in Main: calling tcs1.SetResult(32) ...");
	tcs1.SetResult(32);

	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in Main: calling t2.Result ...");
	string result = t2.Result;
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in Main: t2.Result was \"{result}\"...");
}
Console.WriteLine();
Console.WriteLine("Press ENTER to start example 3 ...");
Console.ReadLine(); 
{
	Task<int> t1 = Task.Run(() => {
		Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in task 1: getting to Sleep(1000) ...");
		Thread.Sleep(1000);
		Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in task 1: returning result 42 ...");
		return 42;
	});
	Task<string> t2 = t1.ContinueWith(prevTask => {
		Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in continuation task 2 ...");
		return $"Result was {prevTask.Result} :)";
	});

	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in Main: calling t2.Result ...");
	string result = t2.Result;
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in Main: t2.Result was \"{result}\"...");
}
Console.WriteLine();
Console.WriteLine("Press ENTER to start example 4 ...");
Console.ReadLine(); 
{
	Task<int> t1 = Task.Run(() => {
		Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in task 1: getting to Sleep(1000) ...");
		Thread.Sleep(1000);
		Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in task 1: returning result 52 ...");
		return 52;
	});
	Task<string> t2A = t1.ContinueWith(prevTask => {
		Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in continuation task 2A ...");
		return $"Result was {prevTask.Result} :)";
	});
	Task<string> t2B = t1.ContinueWith(prevTask => {
		Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in continuation task 2B ...");
		return $"Result was {prevTask.Result} :|";
	});
	Task<string> t2C = t1.ContinueWith(prevTask => {
		Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in continuation task 2C ...");
		return $"Result was {prevTask.Result} :(";
	});

	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in Main: calling Task.WaitAll() ...");
	Task.WaitAll(t2A, t2B, t2C);
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in Main: done ...");
}
