﻿
var t1 = new Task(() => {
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in task 1 ...");
});

var c1A = t1.ContinueWith(_ => {
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in continuation 1 -> 1A ...");
});
var c1B = t1.ContinueWith(_ => {
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in continuation 1 -> 1B ...");
});

var c2 = Task.Factory.ContinueWhenAll(
	new Task[] { c1A, c1B },
	allPrevTasks => {
		Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in continuation 1A & 1B -> 2 ...");
	}
);

Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: calling Task.Delay(2000) ...");
var t3 = Task.Delay(2000);

var t4 = Task.WhenAll(c2, t3);

Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: calling Thread.Sleep(1000) ...");
Thread.Sleep(1000);
Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: calling t1.Start() ...");
t1.Start();

Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: calling t4.Wait() ...");
t4.Wait();
Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: +++ in Main: DONE!");
